package com.vendor.platform.ui.internal;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import com.vendor.platform.api.IDeviceChangedListener;
import com.vendor.platform.api.IDeviceManager;
import com.vendor.platform.api.chips.Chip;
import com.vendor.platform.core.IToolManager;
import com.vendor.platform.core.PlatformCoreActivator;
import com.vendor.platform.core.ToolDescriptor;
import com.vendor.platform.core.internal.DeviceManager;
import com.vendor.platform.ui.internal.BundleUtils;
import com.vendor.platform.ui.internal.PerspectiveUtil;
import com.vendor.platform.ui.internal.PlatformStateControlUtils;
import java.util.List;
import java.util.Map;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.equinox.p2.metadata.IInstallableUnit;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.IMenuListener;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.MenuManager;

public class ToolMenuBuilder implements IMenuListener, IDeviceChangedListener {
  private String subMenuManagerID;
  
  private IMenuManager menuManager;
  
  public ToolMenuBuilder(String subMenuManagerID) {
    this.subMenuManagerID = subMenuManagerID;
    DeviceManager.getInstance().addDeviceChangedListener(this);
  }
  
  public void menuAboutToShow(IMenuManager manager) {
    this.menuManager = manager;
    MenuManager allToolsMenu = (MenuManager)manager.find(this.subMenuManagerID);
    allToolsMenu.removeAll();
    IDeviceManager dm = DeviceManager.getInstance();
    String currentDevice = dm.getCurrentDevice();
    Map<String, IExtension> reg = PerspectiveUtil.loadPerspectiveRegistry();
    IToolManager m = PlatformCoreActivator.getDefault().getToolManager();
    List<IInstallableUnit> installIUs = m.getInstalledToolIUs();
    List<ToolDescriptor> installTools = m.collectFeatureTools(installIUs);
    for (ToolDescriptor t : installTools) {
      if (!BundleUtils.isToolEnabled(t))
        continue; 
      if (!BundleUtils.suitableForChip(t, currentDevice))
        continue; 
      List<String> ids = PerspectiveUtil.finPerspectiveDeclareIds(t, reg);
      if (ids.size() == 0)
        continue; 
      String id = ids.get(0);
      Object object = new Object(this, t.getName(), id);
      object.setEnabled(PlatformStateControlUtils.isPlatformEnabled());
      allToolsMenu.add((IAction)object);
    } 
  }
  
  public void deviceChanged(Chip chip) {
    if (this.menuManager != null)
      menuAboutToShow(this.menuManager); 
  }
}
